var p2 = require('p2');

exports.world = function(context, world) {
  context.save();
  world.bodies.forEach(function(body) {
    drawBody(context, body);
  });
  context.restore();
};

function drawBody(context, body) {
  var aabb = body.aabb;

  if (0) {
    context.save();
    context.setLineDash([5]);
    context.beginPath();

    context.rect(
      aabb.lowerBound[0],
      aabb.lowerBound[1],
      aabb.upperBound[0] - aabb.lowerBound[0],
      aabb.upperBound[1] - aabb.lowerBound[1]
    );
    context.stroke();
    context.restore();
  }

  var pos = body.position;
  context.save();
  context.translate(pos[0], pos[1]);
  context.rotate(body.angle);

  for (var i=0; i<body.shapes.length; i++) {
    var shape = body.shapes[i];
    var offset = shape.position;
    drawShape(context, shape, offset);
  }
  context.restore();
}


function drawShape(context, shape, offset) {

  context.save();
  context.strokeStyle = '#0f0';
  context.translate(offset[0], offset[1]);

  context.beginPath();
  context.moveTo(-5, 0);
  context.lineTo( 5, 0);
  context.moveTo(0, -5);
  context.lineTo(0,  5);
  context.stroke();

  var type = shape.type;

  if (type === p2.Shape.CIRCLE) {
    context.beginPath();
    context.arc(
      0, 0, shape.radius, 0, 2 * Math.PI
    );
    context.stroke();
  }

  if (type === 8) {
    var w = shape.width;
    var h = shape.height;
    context.beginPath();
    context.rect(-w/2, -h/2, w, h);
    context.stroke();
  }

  context.restore();

}
