var frp = require('frp');
var util = require('ace/util');

var sigargs = util.sigargs;

var motion = module.exports;


/* Spinning unit vector */
motion.spin = sigargs(function(update, speed, phase0) {

  phase0 = phase0 || frp.signal.constant(0);

  var angle = phase0.value * 2 * Math.PI;
  var r = frp.cell();
  update.watch(function(dt) {
    angle += dt * speed.value * 2 * Math.PI;
    r.value = [Math.cos(angle), Math.sin(angle)];
  });
  return r.signal;
});
