var _ = require('lodash');

var canvasUtils = require('../canvasUtils');
var T = require('../transform');
var makeView = require('../view');
var util = require('../util');


module.exports = function(ng, spec) {

  var sys = {
    canvas: spec.canvas,
    graphic: spec.graphic
  };

  sys.canvas = spec.canvas;
  sys.graphic = spec.graphic;

  sys.frame = function(dt) {

    if (!sys.canvas)
      return;

    var c = sys.canvas.getContext('2d');
    canvasUtils.clear(c, '#777');

    var view = makeView(c);

    if (sys.graphic)
      sys.graphic.draw(view);

  };

  return sys;

};
