var frp = require('frp');
var graphics = require('ace/graphics');
var _ = require('lodash');
var p2 = require('p2');

var assets = module.exports;

assets.envMat = new p2.Material({relaxation: 5});

var sig = frp.signal.join(_.mapValues({
  tiles: 'assets/ld34/tiles.png',
  growShot: 'assets/ld34/growShot.png',
  mirror: 'assets/ld34/mirror.png',
  bg0: 'assets/ld34/bg0.png',
  bg1: 'assets/ld34/bg1.png',
  bg2: 'assets/ld34/bg2.png',
  bomb0: 'assets/ld34/bomb0.png',
  bomb1: 'assets/ld34/bomb1.png',
  title: 'assets/ld34/title.png',
  win: 'assets/ld34/win.png'
}, graphics.loadImage));

var loaded = frp.cell();
assets.loaded = loaded.signal;

sig.bind(function(x) {
  _.assign(assets, x);
  loaded.set();
});
