var _ = require('lodash');
var frp = require('frp');

module.exports = function(items) {
  items = items || [];

  var cell = frp.cell(items);

  var list = {};

  list.items = cell.signal;

  list.push = function(x) {
    items.push(x);
    cell.set(items);
  };

  list.pull = function(x) {
    _.pull(items, x);
    cell.set(items);
  };

  list.map = function(f) {
    return cell.map(function(items) {
      return _.map(items, f);
    });
  };

  return list;
};
